unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, GLVisir;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    SingleBtn: TButton;
    MultiBtn: TButton;
    GLVisir1: TGLVisir;
    procedure SingleBtnClick(Sender: TObject);
    procedure MultiBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.SingleBtnClick(Sender: TObject);
var mdl:TModelRec; // model
begin
//--- prepare record with model (pyramide) ---
 mdl.nv := 5; // 5 vertexes
 SetLength(mdl.v,mdl.nv); // allocate memory for vertexes
 mdl.np := 5; // 5 Faces (polygons)
 SetLength(mdl.p,mdl.np); // allocate memory for polygons
//--- fill record ---
 //--- pyramide's vertexes ---
  mdl.v[0].x := -1; mdl.v[0].y := -1; mdl.v[0].z := 0;
  mdl.v[1].x := -1; mdl.v[1].y := 1; mdl.v[1].z := 0;
  mdl.v[2].x := 1; mdl.v[2].y := 1; mdl.v[2].z := 0;
  mdl.v[3].x := 1; mdl.v[3].y := -1; mdl.v[3].z := 0;
  mdl.v[4].x := 0; mdl.v[4].y := 0; mdl.v[4].z := 1;
 //--- Pyramide faces ---
  // base polygon
  mdl.p[0].numVertexes := 4; mdl.p[0].col := clRed;
  mdl.p[0].n[0] := 0; mdl.p[0].n[1] := 1; mdl.p[0].n[2] := 2; mdl.p[0].n[3] := 3;
  //--- side polygons
  mdl.p[1].numVertexes := 3; mdl.p[1].col := clRed;
  mdl.p[1].n[0] := 0; mdl.p[1].n[1] := 1; mdl.p[1].n[2] := 4;
  mdl.p[2].numVertexes := 3; mdl.p[2].col := clRed;
  mdl.p[2].n[0] := 1; mdl.p[2].n[1] := 2; mdl.p[2].n[2] := 4;
  mdl.p[3].numVertexes := 3; mdl.p[3].col := clRed;
  mdl.p[3].n[0] := 2; mdl.p[3].n[1] := 3; mdl.p[3].n[2] := 4;
  mdl.p[4].numVertexes := 3; mdl.p[4].col := clRed;
  mdl.p[4].n[0] := 3; mdl.p[4].n[1] := 0; mdl.p[4].n[2] := 4;

 // remove existing frames (1st time - not necessary)
 GLVisir1.Clear;
 // add model to new frame
 GLVisir1.AddModelToNewFrame(mdl);
 // center and zoom added models
 GLVisir1.Fit(false, // don't move coordinates system to zero,
                false  // keep proportions
                );
end;


procedure TForm1.MultiBtnClick(Sender: TObject);
var mdl:TModelRec; // animation frames
    i:integer;
begin
 // remove existing frames (1st time - not necessary)
 GLVisir1.Clear;

 // 10 frames
 for i:=0 to 9 do
 begin
//--- prepare record with model (pyramide) ---
 mdl.nv := 5; // 5 points - vertexes
 SetLength(mdl.v,mdl.nv); // allocate memory for vertexes
 mdl.np := 5; // 5 Faces - polygons
 SetLength(mdl.p,mdl.np); // allocate memory for polygons
//--- fill record ---
 //--- pyramide vertexes ---
  mdl.v[0].x := -1; mdl.v[0].y := -1; mdl.v[0].z := 0;
  mdl.v[1].x := -1; mdl.v[1].y := 1; mdl.v[1].z := 0;
  mdl.v[2].x := 1; mdl.v[2].y := 1; mdl.v[2].z := 0;
  mdl.v[3].x := 1; mdl.v[3].y := -1; mdl.v[3].z := 0;
  mdl.v[4].x := 0; mdl.v[4].y := 0; mdl.v[4].z := i;
 //--- pyramide polygons ---
  // base polygon
  mdl.p[0].numVertexes := 4; mdl.p[0].col := clRed;
  mdl.p[0].n[0] := 0; mdl.p[0].n[1] := 1; mdl.p[0].n[2] := 2; mdl.p[0].n[3] := 3;
  //--- side polygons
  mdl.p[1].numVertexes := 3; mdl.p[1].col := clRed;
  mdl.p[1].n[0] := 0; mdl.p[1].n[1] := 1; mdl.p[1].n[2] := 4;
  mdl.p[2].numVertexes := 3; mdl.p[2].col := clRed;
  mdl.p[2].n[0] := 1; mdl.p[2].n[1] := 2; mdl.p[2].n[2] := 4;
  mdl.p[3].numVertexes := 3; mdl.p[3].col := clRed;
  mdl.p[3].n[0] := 2; mdl.p[3].n[1] := 3; mdl.p[3].n[2] := 4;
  mdl.p[4].numVertexes := 3; mdl.p[4].col := clRed;
  mdl.p[4].n[0] := 3; mdl.p[4].n[1] := 0; mdl.p[4].n[2] := 4;
  // add model to new frame
  GLVisir1.AddModelToNewFrame(mdl);

//--- prepare record with another model (pyramide) ---
 mdl.nv := 5; // 5 vertexes
 SetLength(mdl.v,mdl.nv); // allocate memory
 mdl.np := 5; // 5 Faces
 SetLength(mdl.p,mdl.np); // allocate memory
//--- fill record ---
 //--- pyramide vertexes ---
  mdl.v[0].x := -i; mdl.v[0].y := -i; mdl.v[0].z := 0;
  mdl.v[1].x := -i; mdl.v[1].y := i; mdl.v[1].z := 0;
  mdl.v[2].x := i; mdl.v[2].y := i; mdl.v[2].z := 0;
  mdl.v[3].x := i; mdl.v[3].y := -i; mdl.v[3].z := 0;
  mdl.v[4].x := 0; mdl.v[4].y := 0; mdl.v[4].z := -i;
 //--- pyramide polygons ---
  // base polygon
  mdl.p[0].numVertexes := 4; mdl.p[0].col := clYellow;
  mdl.p[0].n[0] := 0; mdl.p[0].n[1] := 1; mdl.p[0].n[2] := 2; mdl.p[0].n[3] := 3;
  //--- side polygons
  mdl.p[1].numVertexes := 3; mdl.p[1].col := clYellow;
  mdl.p[1].n[0] := 0; mdl.p[1].n[1] := 1; mdl.p[1].n[2] := 4;
  mdl.p[2].numVertexes := 3; mdl.p[2].col := clYellow;
  mdl.p[2].n[0] := 1; mdl.p[2].n[1] := 2; mdl.p[2].n[2] := 4;
  mdl.p[3].numVertexes := 3; mdl.p[3].col := clYellow;
  mdl.p[3].n[0] := 2; mdl.p[3].n[1] := 3; mdl.p[3].n[2] := 4;
  mdl.p[4].numVertexes := 3; mdl.p[4].col := clYellow;
  mdl.p[4].n[0] := 3; mdl.p[4].n[1] := 0; mdl.p[4].n[2] := 4;
  // add model to the same frame
  GLVisir1.AddModelToFrame(mdl,i);
 end;

 // center and zoom added models
 GLVisir1.Fit(false, // don't move coordinates system to zero,
                false  // keep proportions
                );
end;

end.
